<?php 
$title  = "News Nr. 3"; 
$author = "KoMtuR"; 
$date   = time(); 
$desc   = "Von uns erstellt"; 

$doc = DOMDocument::load("news.xml"); 

$xp = new domxpath($doc); 

$id = 0; 
foreach ($doc->documentElement->childNodes as $articles) { 
    if ($articles->nodeType == 1 && $articles->nodeName == "news") { 
        $id++; 
    } 
} 

$id++; 
$newxml = <<< XML 
<news> 
    <id>$id</id> 
    <title>$title</title> 
    <author>$author</author> 
    <description>$desc</description> 
    <date>$date</date> 
</news> 
XML; 

$doc2 = DOMDocument::loadXML($newxml); 
$xpath = new DOMXPath($doc2); 

$query = $xpath->query("/news"); 

foreach($query as $node) { 
    $import = $node->cloneNode(true); 
} 

$onewxml = $doc->importNode($import, true); 

$firstNode = $doc->getElementsByTagName("news"); 

$doc->documentElement->insertBefore($onewxml, $firstNode->item(0)); 
$doc->save("news.xml"); 
?>
