<?php

	function getWidth($myArray) {
    $myLength = 1;
    if (is_array($myArray)) {
      $myTmpLength = 0;
      foreach ($myArray as $myItem )
        $myTmpLength += getWidth($myItem);
      $myLength = floor(sqrt($myTmpLength))+1;
    }
    $myBoxwidth = array();
    $myBoxWidth["x"] = $myLength;
    $myBoxWidth["y"] = floor(sizeOf($myArray)/$myLength);
    return $myLength;
  }
  
  function clusterMe($myArray, $iX, $iY, $iSize, $iDistance, $sParent, $iIteration, $iMaxIteration) {
    $aLength = sizeOf($myArray);
    $newRandom = round(rand());
		$sXML = "var groups$newRandom = document.createElementNS(svgNS, 'g');\n";

    for ($i=0; $i < count($myArray); $i++) {

      $lines =  floor(sqrt($aLength))+1;
      $newXPos   = $iX+(($iSize/$iDistance)*(($i%$lines)));
  		$newYPos   = $iY+(($iSize/$iDistance)*floor($i/$lines));

      //$newRadius = round($iSize/30);
      $newRadius = round(($iSize/$iDistance)*getWidth($myArray[$i]));
      $sXML .= "var group$i$newRandom = document.createElementNS(svgNS, 'g');\n";
      $sXML .= "group$i$newRandom.setAttribute('class','mapLayer$iIteration');\n";
      $sXML .= "groups$newRandom.appendChild(group".$i.$newRandom.");\n";
      $sXML .= $sParent.".appendChild(group".$i.$newRandom.");\n";
      
      if (!is_array($myArray[$i])
          &&($iIteration < $iMaxIteration)) {
			  $sXML .= "var group".$i.$newRandom."image = document.createElementNS(svgNS, 'image');\n";
        $sXML .= "group".$i.$newRandom."image.setAttributeNS(xlinkNS,'href','img/products/".$myArray[$i]."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('id','".$myArray[$i]."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('class','prod_body');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('x','".($newXPos-floor($newRadius/2)+floor(($iSize/$iDistance)/2))."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('y','".($newYPos-floor($newRadius/2)+floor(($iSize/$iDistance)/2))."');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('width','$newRadius');\n";
        $sXML .= "group".$i.$newRandom."image.setAttribute('height','$newRadius');\n";                               
        $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."image);\n";         
      }

      $sXML .= "group$i$newRandom.setAttribute('id','group$i$newRandom');\n";      
      $sXML .= "var group".$i.$newRandom."rect = document.createElementNS(svgNS, 'rect');\n";
      $sXML .= "group".$i.$newRandom."rect.setAttribute('x','".($iX+(($iSize/$iDistance)*(($i%$lines))))."');\n";
      $sXML .= "group".$i.$newRandom."rect.setAttribute('y','".($iY+(($iSize/$iDistance)*floor($i/$lines)))."');\n";

      $sXML .= "group".$i.$newRandom."rect.setAttribute('width','".($newRadius)."');\n";
      $sXML .= "group".$i.$newRandom."rect.setAttribute('height','".($newRadius)."');\n";

      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."rect);\n";


			if (is_array($myArray[$i])
          &&($iIteration < $iMaxIteration))
			 $sXML .= clusterMe($myArray[$i], $newXPos, $newYPos, round(($iSize/$iDistance)/$lines), $iDistance, "group".$i.$newRandom, $iIteration+1 , $iMaxIteration);

		} //FOR

	 return $sXML; 
  } //Function
?>
