<?php
header("Content-type:application/xhtml+xml");
require_once("area_library_2007_02_22.php");

function getPage($pageId) {
	$objResponse = new xajaxResponse();
/*  	$newContent = implode('', file('http://www.l-ray.de/index.php?id='.$pageId.'&type=22'));
	//$newContent = "<h1>hallo</h1>";
	$objResponse->addAssign("siteContent", "innerHTML", $newContent);
	$objResponse->addScript('reparsePage();');*/
	return $objResponse;
}

$xajax->registerFunction("getPage");
$xajax->processRequests();

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html 
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:s="http://www.w3.org/2000/svg"
	xml:lang="de-DE">
  <head>
    <title>JavaScript-OOP</title>

    <link rel="stylesheet" type="text/css" href="vTnT_typo.css" />   
    <?php $xajax->printJavascript(); ?>
    <script type="text/javascript" src="/typo3/contrib/prototype/prototype.js"></script>
    <script type="text/javascript" src="/typo3/contrib/scriptaculous/effects.js" ></script>    
    <script type="text/javascript" src="js/class.User.js"             ></script>
    <script type="text/javascript" src="js/class.Product.js"          ></script>
    <script type="text/javascript" src="js/class.ProductCategory.js"  ></script>
    <script type="text/javascript" src="js/class.ProductDetailsView.js" ></script>
    <script type="text/javascript" src="js/class.Observable.js"        ></script>
    <script type="text/javascript" src="js/class.AvatarAsDecorator.js" ></script>
    <script type="text/javascript" src="js/class.vTnTModel.js"         ></script>
    <script type="text/javascript" src="js/class.AvatarControl.js"     ></script>
    <script type="text/javascript" src="js/class.AvatarView.js"        ></script>    
    <script type="text/javascript" src="js/class.AvatarDetailsView.js" ></script>
    <script type="text/javascript" src="js/class.AvatarIdControl.js"   ></script>
    <script type="text/javascript" src="js/class.AvatarIdView.js"      ></script>
    <script type="text/javascript" src="js/class.MapView.js"           ></script>
    <script type="text/javascript" src="js/class.SliderView.js"        ></script>
    <script type="text/javascript" src="js/class.SliderControl.js"     ></script>
    <script type="text/javascript" src="js/class.VisualMap.js"         ></script>    
    <script type="text/javascript" src="js/class.TextBoxView.js"       ></script>
    <script type="text/javascript" src="js/class.TextLineDecorator.js" ></script>
    <script type="text/javascript" src="js/class.TextLine.js"          ></script>
    <script type="text/javascript" src="js/class.TextLineControl.js"   ></script>
    <script type="text/javascript" src="js/class.TextLineView.js"      ></script>    
    <script type="text/javascript" src="js/func.extScriptalicious.js"  ></script>    
    <!-- <script type="text/javascript" src="../typo3wamp/index.php?id=24" ></script>-->
    <script type="text/javascript" src="lib/log4js.js"           ></script> 
    <script type="text/javascript" src="js/md5.js"      ></script> 
    
    <script type="text/javascript">
 <![CDATA[
     //initialize the logger  with your category 
      var oLogger = Log4js.getLogger("vtntTest"); 

     // some facts
   	var svgNS = 'http://www.w3.org/2000/svg';
    var xhtmlNS = 'http://www.w3.org/1999/xhtml';
  	var xlinkNS = 'http://www.w3.org/1999/xlink';
    var iAktiveSeconds = 120;
   

    function setAvatar(sId, sNick, iX, iY, iL, bA, iSec, dLastSeen, dLastMoved, sName, sCompany, sPosition, sEMail, sPicUrl) {
/*      logger.debug("root.setAvatar "+sId+", "+sNick+", "+iX+", "+iY+", "
                                    +iL+", "+bA+", "+iSec+", "+dLastSeen+", "+dLastMoved);*/
      var tmpUser = new User();
      tmpUser.setId(sId);
      tmpUser.setNick(sNick);
      tmpUser.setX(iX);
      tmpUser.setY(iY);
      tmpUser.setLoudness(iL);
      tmpUser.setActive(bA);
      tmpUser.setLastAction(iSec);
      tmpUser.setLastSeen(dLastSeen);
      tmpUser.setLastMoved(dLastMoved);
      tmpUser.setName(sName);
      tmpUser.setCompany(sCompany);
      tmpUser.setPositionName(sPosition);
      tmpUser.setEmail(sEMail);
      tmpUser.setPicUrl(sPicUrl);      

      myModel.updateUser(tmpUser, false);
    }
    
    function setTextLine(sId, sSId, iX, iY,  iLoudness, sText, dTimestamp) {
        /*logger.debug("setTextLine:"+sId);*/
        var tmpTextLine = new TextLine();
        tmpTextLine.setId(sId);
        tmpTextLine.setSId(sSId),
        tmpTextLine.setX(iX);
        tmpTextLine.setY(iY);
        tmpTextLine.setLoudness(iLoudness);
        tmpTextLine.setText(sText);
        tmpTextLine.setTimestamp(dTimestamp);
        
        myModel.addTextLine(tmpTextLine, false);
        //myModel.updateTextLine(tmpTextLine, false);
    }


    function setCurrentUTimestamp(sDate) {
      myModel.setUTimestamp(sDate);
      /*logger.debug("setCurrentUTimestamp "+sDate);*/
    }
    
    function setCurrentTextTimestamp(sDate) {
      myModel.setTextTimestamp(sDate);
      /*logger.debug("setCurrentTextTimestamp "+sDate);*/
    }

    function notifyObservers(aArray) {
      myModel.notifyObservers(aArray);
    }
   ]]>  
</script>
</head>
<body id="testBody">

<!-- PArt, that's doing the SVG-Thing -->
    <div id="vTnT" style="padding-left: 100px;">
      <div id="vTnTVisual"> 
        <script type="text/javascript">
        <![CDATA[
       
      //set the level of logging 
      oLogger.setLevel(Log4js.Level.INFO); 
      //set the Appender to write the log to 
      oLogger.addAppender(new ConsoleAppender(oLogger, true)); 


       var myModel = new vTnTModel();
      //doSomeDummyContent(myModel);

      var myAvatar = new User();
      myAvatar.setX(Number(90+Math.round(Math.random()*90)));
      myAvatar.setY(Number(175+Math.round(Math.random()*175)));    
      myAvatar.setId("0001");
    	myAvatar.setName("myName"+Math.round(Math.random()*1000));
    	myAvatar.setActive(0);
    	myAvatar.setLoudness(40);
    	myAvatar.setOwn(true);
    	myAvatar.setLastAction("0");
    	myAvatar.setLastMoved("0");
    	myAvatar.setLastSeen("0");
      myModel.updateUser(myAvatar);

      myModel.getUserDataFromServer();
      myModel.getTextDataFromServer()

      var cAktivUserExchange = new PeriodicalExecuter(
        function() { myModel.getUserDataFromServer();}
        , 12);

      var cTextLineExchange  = new PeriodicalExecuter(
        function() { myModel.getTextDataFromServer();}
          , 8);

    // View, Uebergabe des Model
    //var view = new View( );

    var control = new VisualMap(myModel, "Nutzer-Control");
        control.setWidth("420");
        control.setHeight("350");

        control.setAttribute('onmousedown','control.getControl().grab(evt)');
        control.setAttribute('onmousemove','control.getControl().drag(evt)');
        control.setAttribute('onmouseup'  ,'control.getControl().drop(evt)');
        control.setAttribute('onmouseover','control.getControl().over(evt)');
        control.setAttribute('onmouseout' ,'control.getControl().out(evt)');
   
    // Reihenfolge beachten, da sonst avatare unter Produkten liegen könnten. 
    var mapView = new MapView(myModel,"Landkarten-Metapher.");
        control.add(mapView);

    var avatarView = new AvatarView(myModel,"View mit den bunten Kreisen.");
        control.add(avatarView);
        document.getElementById('vTnTVisual').appendChild(control.paint());    

    var sliderView = new SliderView(myModel,"Zooming-Slider.", "sliderView");

    var textBoxView = new TextBoxView(myModel,"textBoxView");
    var textLineView = new TextLineView(myModel,"textLineView");

    var textLineControl = new TextLineControl(myModel, "TextLineControl", myModel.getOwnUser()[0]);
    textBoxView.setController(textLineControl);
    textBoxView.setView(textLineView);
    
    var ownAvatarIdView = new AvatarIdView(myModel, "ID-View", myModel.getOwnUser()[0]);
        ownAvatarIdView.setAction('ownAvatarIdControl.setProperties();');
    
    var ownAvatarIdControl = new AvatarIdControl(myModel, "ID-Control zur Anpassung der persoenlichen Daten", myModel.getOwnUser()[0]);

    var avatarDetailsView = new AvatarDetailsView(myModel, "haelt die Details zu Nutzern, welche per mouseOver ausgewaehlt wurden.");
    var productDetailsView = new ProductDetailsView(myModel, "zeigt per MouseOver markierte Produkte im Detail an.");
    productDetailsView.setProduct(myModel.oProducts[0]);
    
        function getPageSize(){
          	
          	var xScroll, yScroll;
          	
          	if (window.innerHeight && window.scrollMaxY) {	
          		xScroll = document.body.scrollWidth;
          		yScroll = window.innerHeight + window.scrollMaxY;
          	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
          		xScroll = document.body.scrollWidth;
          		yScroll = document.body.scrollHeight;
          	} else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
          		xScroll = document.body.offsetWidth;
          		yScroll = document.body.offsetHeight;
          	}
          	
          	var windowWidth, windowHeight;
          	if (self.innerHeight) {	// all except Explorer
          		windowWidth = self.innerWidth;
          		windowHeight = self.innerHeight;
          	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
          		windowWidth = document.documentElement.clientWidth;
          		windowHeight = document.documentElement.clientHeight;
          	} else if (document.body) { // other Explorers
          		windowWidth = document.body.clientWidth;
          		windowHeight = document.body.clientHeight;
          	}	
          	
          	// for small pages with total height less then height of the viewport
          	if(yScroll < windowHeight){
          		pageHeight = windowHeight;
          	} else { 
          		pageHeight = yScroll;
          	}
          
          	// for small pages with total width less then width of the viewport
          	if(xScroll < windowWidth){	
          		pageWidth = windowWidth;
          	} else {
          		pageWidth = xScroll;
          	}
          	arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight) 
          	return arrayPageSize;
          }  
]]>
</script>
    </div> <!-- vTNT-Visual -->

        <div id="vTnTAdmin">
          <button id="vTnTInputFormInput2"  name="input" title="manually repings data from server" onclick="myModel.getUserDataFromServer();">Ping</button>	
          <button id="vTnTInputFormInput3"  name="input" title="manually checks for new messages" onclick="myModel.getTextDataFromServer();">CaD</button>
        	<button id="vTnTInputFormInput1"  name="input" title="deletes all user" onclick="xajax_deleteAllUser();">DaU</button>
        	<button id="vTnTInputFormInput4"  name="input" title="dummy Data" onclick="myModel.doSomeDummyContent();">dummyContent</button>
        	<button id="vTnTInputFormInput5"  name="input" title="testLogger" onclick="oLogger.warn('hallo');">testLogger</button>
        	<button id="vTnTInputFormInput6"  name="input" title="Zoom1" onclick="myModel.setZoomLevel(1);">1:1</button>
        	<button id="vTnTInputFormInput7"  name="input" title="zoom in" onclick="myModel.setZoomLevel((myModel.getZoomLevel()*1.2));">+</button>
        	<button id="vTnTInputFormInput8"  name="input" title="zoom out" onclick="myModel.setZoomLevel((myModel.getZoomLevel()*0.8));">-</button>
        	<button id="vTnTInputFormInput9"  name="input" title="effect" onclick="new Effect.Appear('overlay', { duration: 0.2, from: 0.0, to: 0.8 });;">effect</button>
          <button id="vTnTInputFormInput10" name="input" title="go to portal-size" onclick="control.getControl().doWithUser('mini');">mini</button>	
          <button id="vTnTInputFormInput10" name="input" title="go to maximized size" onclick="control.getControl().doWithUser('maxi');">maxi</button>
       </div>

  <s:svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"
    onload="sliderView.getControl().getSVGDoc(evt)" id="vTnTSlider" 
    style="z-index: 11000;display: block;position:absolute;"
    viewBox="0 0 170 20"
    width="170" height="20">
  
    <s:title>SVG - Learning By Coding</s:title>
    <s:desc>SVG-Spezifikation in Beispielen</s:desc>
  </s:svg>

        <script type="text/javascript">
    <![CDATA[
// anderer Controller (TextLine)            
            $('vTnT').appendChild(textBoxView.paint());

            $('vTnT').appendChild(ownAvatarIdView.paint());
            $("vTnTSlider").appendChild(sliderView.paint());
            sliderView.getControl().init();
          //  control.getControl().doWithUser('mini');
            $('vTnT').appendChild(avatarDetailsView.paint());
            $('vTnT').appendChild(productDetailsView.paint());          
          
          //Mausrad ansteuern
          /** Initialization code. 
           * If you use your own event management code, change it as required.
           */          
          if (document.getElementById('vTnT').addEventListener)
                  document.getElementById('vTnT').addEventListener('DOMMouseScroll', sliderView.getControl().wheel, false);

          /** IE/Opera. */
          window.onmousewheel = document.onmousewheel = sliderView.getControl().wheel;
]]></script>   
</div>
<!-- Part, that does the background -->
<div id="vTnTBackground" style="display: none; position: absolute; top:0px; left:0px; background-color:#000000; opacity: 0.8;"> </div>

</body>
</html>
 