/**
 * Textline-Objekt
 * 
 * hlt die zu einem Text-Eintrag gehrenden Eigenschaften.
 * 
 * @author lray
 * @version 2007-02-15
 */      

  var TextLine = Class.create();
  TextLine.prototype = {
   
    oLogger:Object(),   
    iXPos:Number(0),
  	iYPos:Number(0),
  	iLoudness:Number(0),
  	iSId:String(),
    iId:String(),
  	sText:String(),
  	iTimestamp: Number(0),
    iTextLength : Number(-1),
    iDistance: Number(0),

    initialize: function() {
         //open maingroup
      this.oLogger = new Log4js.getLogger("vtntTest");
      this.oLogger.debug("single TestLine initiated");
      
      //alert(this.iTimestamp);
    },

    notify: function() {
      this.oLogger.warn("TextLine-Class "+this.getId()+" notified, but not yet implemented.");
    },

    remove: function() {
		// to be filled
    },

  	setX: function(xpos) { 
      this.iXPos = xpos;
    },
  	getX: function() { return this.iXPos;},

  	setY: function(ypos) {
      this.iYPos = ypos;
    },
  	getY: function() {return this.iYPos;},

    /**
     *getDistance
     *gibt die direkte Entfernung zwischen einem Punkt und der eigenen aktuellen Position zurck.
     *
     * @param Number Abszisse des Punktes
     * @param Number Ordinate des Punktes
     * @return Number Distanz zum Punkt
     * @author lray
     * @version 2007-02-15
     */                                            
    getDistance: function() {
      return this.iDistance;
    },

    setDistance: function(xpos, ypos) {
      this.iDistance = Math.round(
                              Math.sqrt(
                                Math.pow((xpos - this.getX()),2)+Math.pow((ypos - this.getY()),2)
                              )
                           );
      this.oLogger.debug("TextLine.setDistance(x,y): ("
                          +this.getX()+","+this.getY()+")+("+xpos+","
                          +ypos+")="+this.getDistance());
                                   
    },

  	setId: function(id) {
      this.iId = id;
    },
  	getId: function() {return this.iId;},
  
  	setSId: function(id) {
      this.iSId = id;
    },
  	getSId: function() {return this.iSId;},

    setTimestamp: function(item) {
      if (item instanceof Date)
        this.iTimestamp = Number(item.getTime());
      else this.iTimestamp = item;  

    },
    
  	getTimestamp: function() {return this.iTimestamp;},
     
    setText: function(item) {
      this.sText = item;
    },
  	getText: function() {return this.sText;},

    setLoudness: function(item) {
      this.iLoudness = item;
    },
  	getLoudness: function() {return this.iLoudness;},
}
