<?php 
header("Content-type:application/xhtml+xml");
require_once("xajax.inc.php");
$xajax = new xajax();
$xajax->debugOn();

//      $aProducts = Array("A","B","C","D","E");
		$aProducts = Array(Array("A","B","C","D","E"),
  		"F",
  		Array("G","H",Array("I","J","K","L", Array("R","S","Y","Z")),"M"),
  		"N",
  		"O",
  		Array("T","U","V","W","X"),
  		"Q"
  	);


function getMapData($sParent, $iMaxIteration) {
	global $aProducts;
  $objResponse = new xajaxResponse(); 
    $objResponse->addScript(clusterMe($aProducts, 150, 150, 150, 1.5, $sParent, 1, $iMaxIteration));
  return $objResponse;
}

  function testMe() {
    return "<circle cx='20' cy='20' r='50' />";
  }

//---------------
	function clusterMe($myArray, $iX, $iY, $iSize, $iDistance, $sParent, $iIteration, $iMaxIteration) {
    $aLength = sizeOf($myArray);
    $newRandom = round(rand());
		$sXML = "var groups$newRandom = document.createElementNS(svgNS, 'g');\n";	
    $aCoordinates = Array();
    $aCoordinatesForPathHelpers = Array();

    for ($i=0; $i < count($myArray); $i++) {

  		$newXPos   = $iX+round(($iSize/$iDistance)*sin(($i*(360/$aLength))/180 * pi()));
  		$newYPos   = $iY+round(($iSize/$iDistance)*cos(($i*(360/$aLength))/180 * pi()));
      $newRadius = round($iSize/30);
      
      $aCoordinates[$i]= Array($newXPos,$newYPos);
      
      $sXML .= "var group$i$newRandom = document.createElementNS(svgNS, 'g');\n";
      $sXML .= "groups$newRandom.appendChild(group".$i.$newRandom.");\n";
      $sXML .= $sParent.".appendChild(group".$i.$newRandom.");\n";

      /** falls schon ein Wert existiert, seine Lnge dritteln, den Entfernung zum Mittel-
       * punkt vektorisieren und mit der Lnge ausfahren
       * TODO: bessere Erklrung einfhren       
       */             
      
      if ($i > 0) {
        $iXDist = $aCoordinates[$i][0] - $aCoordinates[$i-1][0];
        $iYDist = $aCoordinates[$i][1] - $aCoordinates[$i-1][1];
        $rGDist = round((sqrt(pow($iXDist,2)+pow($iYDist,2)))/3);
        
        $iXVector = $iX- $newXPos;
        $iYVector = $iY - $newYPos;
        $iVector = ($iYVector / $iXVector);
       
        $sXML .= "var group".$i.$newRandom."1line = document.createElementNS(svgNS, 'line');\n";
        $sXML .= "group".$i.$newRandom."1line.setAttribute('x1','".($newXPos+($rGDist*$iVector*(-1)))."');\n";
        $sXML .= "group".$i.$newRandom."1line.setAttribute('y1','".($newYPos+($rGDist))."');\n";
        $sXML .= "group".$i.$newRandom."1line.setAttribute('x2','".($newXPos-($rGDist*$iVector*(-1)))."');\n";
        $sXML .= "group".$i.$newRandom."1line.setAttribute('y2','".($newYPos-($rGDist))."');\n";
        $sXML .= "group".$i.$newRandom."1line.setAttribute('style','fill:none;stroke:black;stroke-width:0.5;');\n";
        $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."1line);\n";      
        $sXML .= "alert('$iVector: ".pow($iXDist,2)." und ".pow($iYDist,2).": ".$rGDist."');";
  
        
        $aCoordinatesForPathHelpers[$i*2+1] = Array(round($newXPos-($rGDist*$iVector*(-1))),round($newYPos-($rGDist)));
        $aCoordinatesForPathHelpers[$i*2] = Array(round($newXPos+($rGDist*$iVector*(-1))),round($newYPos+($rGDist)));      
      }      

      // einzeln fr Nullpunkt
      if ($i == (count($myArray)-1)) {
/*        $iXDist = $aCoordinates[0][0] - $aCoordinates[$i][0];
        $iYDist = $aCoordinates[0][1] - $aCoordinates[$i][1];
        $rGDist = round((sqrt(pow($iXDist,2)+pow($iYDist,2)))/3);
        
        $iXVector = $iX - $aCoordinates[0][0];
        $iYVector = $iY - $aCoordinates[0][1];
        $iVector = ($iYVector / $iXVector);

        $aCoordinatesForPathHelpers[0] = Array(round($newXPos-($rGDist*$iVector*(-1))),round($newYPos-($rGDist)));
        $aCoordinatesForPathHelpers[1] = Array(round($newXPos+($rGDist*$iVector*(-1))),round($newYPos-($rGDist)));            
*/      }
     
      $sXML .= "group$i$newRandom.setAttribute('id','group$i$newRandom');\n";      
      $sXML .= "var group".$i.$newRandom."circle = document.createElementNS(svgNS, 'circle');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('cx','$newXPos');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('cy','$newYPos');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('r','$newRadius');\n";
      $sXML .= "group".$i.$newRandom."circle.setAttribute('style','fill:none;stroke:black;stroke-width:0.5;');\n";

      $sXML .= "var group".$i.$newRandom."line = document.createElementNS(svgNS, 'line');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('x1','$iX');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('y1','$iY');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('x2','$newXPos');\n";
      $sXML .= "group".$i.$newRandom."line.setAttribute('y2','$newYPos');\n";            
      $sXML .= "group".$i.$newRandom."line.setAttribute('style','fill:none;stroke:black;stroke-width:0.5;');\n";
      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."line);\n";
      $sXML .= "group".$i.$newRandom.".appendChild(group".$i.$newRandom."circle);\n";         

			if (is_array($myArray[$i])
          &&($iIteration < $iMaxIteration))
			 $sXML .= clusterMe($myArray[$i], $newXPos, $newYPos, round($iSize/3), $iDistance, "group".$i.$newRandom, $iIteration+1 , $iMaxIteration);

		} //FOR

    //zeichne Pfadelement um gesamte Punkte herum.
    $sXMLTest = "var groups".$newRandom."path = document.createElementNS(svgNS, 'path');";
    $sXMLTest .= "groups".$newRandom."path.setAttribute('style','fill:none;stroke:black;stroke-opacity:1');";
    $sXMLTest .= "groups".$newRandom."path.setAttribute('d','M";
//      $sXMLTest .= "alert('";
   for ($j=1; $j < count($aCoordinates); $j++) {
      $sXMLTest .= $aCoordinates[$j][0].",".$aCoordinates[$j][1]." ";
      if ($j<(count($aCoordinates)-1)) {
        $sXMLTest .= "C ".$aCoordinatesForPathHelpers[$j*2][0].",".$aCoordinatesForPathHelpers[$j*2][1]." ".
                     $aCoordinatesForPathHelpers[$j*2+1][0].",".$aCoordinatesForPathHelpers[$j*2+1][1]." ";

        $sXML .= "var group".$j.$newRandom."1line = document.createElementNS(svgNS, 'line');\n";
        $sXML .= "group".$j.$newRandom."1line.setAttribute('x1','".$aCoordinatesForPathHelpers[$j*2+1][0]."');\n";
        $sXML .= "group".$j.$newRandom."1line.setAttribute('y1','".$aCoordinatesForPathHelpers[$j*2+1][1]."');\n";
        $sXML .= "group".$j.$newRandom."1line.setAttribute('x2','".$aCoordinatesForPathHelpers[$j*2+2][0]."');\n";
        $sXML .= "group".$j.$newRandom."1line.setAttribute('y2','".$aCoordinatesForPathHelpers[$j*2+2][1]."');\n";
        $sXML .= "group".$j.$newRandom."1line.setAttribute('style','fill:none;stroke:black;stroke-width:0.5;');\n";
        $sXML .= "vTnTMapArea.appendChild(group".$j.$newRandom."1line);\n";      
        $sXML .= "alert('$iVector: ".pow($iXDist,2)." und ".pow($iYDist,2)."');";
      }
//      else
//        $sXMLTest .= "Q".($aCoordinates[$j][0]+0.3*($aCoordinates[0][0]-$aCoordinates[$j][0])).",".($aCoordinates[$j][1]+0.7*($aCoordinates[0][1]-$aCoordinates[$j][1]))." ";              
    }
    $sXMLTest .= $aCoordinates[0][0].",".$aCoordinates[0][1]." ";
//    $sXMLTest .= $aCoordinates[$j+1][0].",".$aCoordinates[$j+1][1];
    $sXMLTest .= "');";
    $sXMLTest .= " vTnTMapArea.appendChild(groups".$newRandom."path);";
		$sXML .= $sXMLTest;	

	 return $sXML; 
  } //Function

//---------------

$xajax->registerFunction("getMapData");
$xajax->processRequests();
?>
<?xml version='1.0'?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de-DE">
<head>
	<title>Test-SVG</title>
    <?php $xajax->printJavascript(); ?>
    <script type="text/javascript" src="litebox-1.0/js/prototype.js" onerror="alert('konnte prototype.js nicht laden');"></script>
    <script type="text/javascript" src="litebox-1.0/js/effects.js"   onerror="alert('konnte effects.js nicht laden');"></script>    
    <script type="text/javascript" src="func.extScriptalicious.js"   onerror="alert('konnte func.extScriptalicious.js nicht laden');"></script>    

</head>
<body style="background-color: yellow;">
<svg
   xmlns:svg="http://www.w3.org/2000/svg"
   xmlns="http://www.w3.org/2000/svg"
   version="1.0"
   width="600"
   height="300"
   
   id="svg2"
	>
  <defs
     id="defs4" />
	<g id="mainLayer">
		<g
		id="layer1" transform="translate(150, 150)">
			<circle cx="0" cy="0" r="5" />
		</g>
	</g>
		<g id="vTnTMapArea">
	</g>
</svg>
Dies ist der Testbereich

 <script type="text/javascript"><![CDATA[
 	var svgNS = 'http://www.w3.org/2000/svg';
	var xhtmlNS = 'xmlns="http://www.w3.org/1999/xhtml';
	var xlinkNS = 'http://www.w3.org/1999/xlink';

  
  var vTnTMapArea = document.getElementById("vTnTMapArea");
  xajax_getMapData('vTnTMapArea', 1);

 ]]></script>
</body>
</html>
