#
# Table structure for table 'tx_vtnt_chatlog'
#
CREATE TABLE tx_vtnt_chatlog (
   uid int(11) unsigned DEFAULT '0' NOT NULL auto_increment,
   pid int(11) unsigned DEFAULT '0' NOT NULL,  
   sid int(11) unsigned DEFAULT '0' NOT NULL,
   entry text NOT NULL,
   xpos int(11) DEFAULT '0' NOT NULL,
   ypos int(11) DEFAULT '0' NOT NULL,
   loudness int(11) DEFAULT '0' NOT NULL,
   
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   crdate int(11) unsigned DEFAULT '0' NOT NULL,
   cruser_id int(11) DEFAULT '0' NOT NULL, 
   deleted tinyint(4) DEFAULT '0' NOT NULL,  
   hidden tinyint(4) DEFAULT '0' NOT NULL,
   feuser blob,
   tofeuser int(11) DEFAULT '0' NOT NULL,	
   
   PRIMARY KEY  (uid),
   KEY parent (pid)
);

#
# Table structure for table 'tx_vtnt_sessions'
#
CREATE TABLE tx_vtnt_sessions (
  
  uid int(11) NOT NULL auto_increment,
  pid int(11) DEFAULT '0' NOT NULL,
  sessionid varchar(255) DEFAULT '0' NOT NULL,
  nick varchar(255) DEFAULT '0' NOT NULL,
  xpos mediumint(9) DEFAULT '0' NOT NULL,
  ypos mediumint(9) DEFAULT '0' NOT NULL,
  loudness mediumint(9) DEFAULT '0' NOT NULL, 
  lastseen int(11) unsigned DEFAULT '0' NOT NULL,
  lastmoved int(11) unsigned DEFAULT '0' NOT NULL,
  lastaction int(11) unsigned DEFAULT '0' NOT NULL,
  chatter tinyint(1) DEFAULT '0' NOT NULL,
  name varchar(255) DEFAULT '',
  company varchar(255) DEFAULT '',
  cposition varchar(255) DEFAULT '',
  picurl varchar(255) DEFAULT '',
  tstamp int(11) unsigned DEFAULT '0' NOT NULL,  
  crdate int(11) unsigned DEFAULT '0' NOT NULL,
  cruser_id int(11) DEFAULT '0' NOT NULL,
	
  deleted tinyint(4) DEFAULT '0' NOT NULL,
  hidden tinyint(4) DEFAULT '0' NOT NULL,
  starttime int(11) DEFAULT '0' NOT NULL,
  endtime int(11) DEFAULT '0' NOT NULL,

PRIMARY KEY  (uid),
 KEY  (sessionid)
);

#
# Table structure for table 'pages'
#
CREATE TABLE pages (
   tx_vtnt_pageobject mediumtext NOT NULL,
   tx_vtnt_pageobject_image blob NOT NULL,
   tx_vtnt_xpos int(11) DEFAULT '0' NOT NULL,
   tx_vtnt_xsize int(11) DEFAULT '0' NOT NULL,
   tx_vtnt_ypos int(11)  DEFAULT '0' NOT NULL,
   tx_vtnt_ysize int(11) DEFAULT '0' NOT NULL,
);
