<?php
require_once(PATH_t3lib."class.t3lib_extobjbase.php");

class tx_vtnt_modfunc1 extends t3lib_extobjbase
{
	
	
	function modMenu()
	{
		global $LANG;

		return array (
			"tx_vtnt_modfunc1_check" => "",	
			'depth' => array(
		0 => $LANG->sL('LLL:EXT:lang/locallang_core.php:labels.depth_0'),
		1 => $LANG->sL('LLL:EXT:lang/locallang_core.php:labels.depth_1'),
		2 => $LANG->sL('LLL:EXT:lang/locallang_core.php:labels.depth_2'),
		3 => $LANG->sL('LLL:EXT:lang/locallang_core.php:labels.depth_3'),
		),
			'tx_vtnt_modfunc1_algorithm' => array(
				'circle' => $LANG->getLL('circle'),
				'square' => $LANG->getLL('square')
		)
		);
	}

	function doTree() {
		$treeStartingPoint = intval($this->pObj->id);
		$treeStartingRecord = t3lib_BEfunc::getRecord('pages', $treeStartingPoint);
		$depth = $this->pObj->MOD_SETTINGS['depth'];

		// Initialize tree object:
		$tree = t3lib_div::makeInstance('t3lib_treeView');
		$tree->init('');

		// Creating top icon; the current page
		$tree->tree[] = array(
			'row' => $treeStartingRecord,
		);

		// Create the tree from starting point:
		if ($depth>0)	{
			$tree->getTree($treeStartingPoint, $depth, '');
		}

		foreach($tree->tree as $row) {
			foreach ($row["row"] AS $key => $value) {
				$theCode .= "<br /> $key => $value";
			}

		}
		return $theCode;
	}

	/**
	 * Enter description here...
	 *
	 * @param unknown_type $myArray
	 * @param unknown_type $iX
	 * @param unknown_type $iY
	 * @param unknown_type $iSize
	 * @param unknown_type $iDistance
	 * @param unknown_type $sParent
	 * @param unknown_type $iIteration
	 * @param unknown_type $iMaxIteration
	 * @return unknown
	 */
	function clusterMeAsArray($myArray, $iX, $iY, $iSize, $iDistance, $sParent, $iIteration, $iMaxIteration) {
		$aLength = sizeOf($myArray);

		$newArray = array();

		if ($aLength > 0) {

			$i=0;
			
		   $alpha = deg2rad(360/$aLength);
		   $newRadius = 0;
		   $oldRadius = 10;
		   $i =0;	
		   while (abs($oldRadius-$newRadius)>round($newRadius*0.05)&&$i<30) {
			    $oldRadius = $newRadius;
			    $i++;
		
			    $newXPos1   = $iX+round((($iSize/2)-$newRadius)*sin($alpha));
				$newYPos1   = $iY+round((($iSize/2)-$newRadius)*cos($alpha));
			    $newXPos2   = $iX+round((($iSize/2)-$newRadius)*sin(2*$alpha));
				$newYPos2   = $iY+round((($iSize/2)-$newRadius)*cos(2*$alpha));
				$newRadius = round(sqrt(pow(($newXPos2-$newXPos1),2)+pow(($newYPos2-$newYPos1),2))/2);
		    }
			
			foreach ($myArray AS $myArrayKey => $myArrayValue) {
				
				$i++;
				$uid = $myArrayKey;
				print("my Array-Key:".$uid);
				
				$newXPos   = $iX+round((($iSize/2)-$newRadius)*sin($i*$alpha));
				$newYPos   = $iY+round((($iSize/2)-$newRadius)*cos($i*$alpha));
				
				$newArray[$uid."_"]["xpos"]= round($newXPos-$newRadius);
				$newArray[$uid."_"]["ypos"]= round($newYPos-$newRadius);
	
				$newArray[$uid."_"]["xsize"]= 2*$newRadius;
				$newArray[$uid."_"]["ysize"]= 2*$newRadius;
	
				$newArray[$uid."_"]["svg"]="<circle xmlns='http://www.w3.org/2000/svg' class='prod_circle' cx='$newRadius' cy='$newRadius' r='$newRadius' />";
				if (is_array($myArrayValue) 
					&& count($myArrayValue)>0
					&&($iIteration < $iMaxIteration)
				){
					$newArray=array_merge($newArray,$this->clusterMeAsArray($myArrayValue, $newRadius, $newRadius, 2*$newRadius, $iDistance, "", $iIteration+1 , $iMaxIteration));
				}
	
			} //FOR
		}
		print_r($newArray);
		return $newArray;
	}

	function getMenuItemTree($uid,$depth) {

		$newMenuItems = array();
		if ($depth >=0) {
			$sys_pages = t3lib_div::makeInstance('t3lib_pageSelect');
			$menuItems=array();
			$menuItems = $sys_pages->getMenu($uid,'uid,pid,title',$sortByField,' AND pages.hidden=0 AND pages.nav_hide=0',0);

			if (count($menuItems))	{

				$menuItems = array_reverse($menuItems);
				reset($menuItems);
					
				while(list($t,$r)=each($menuItems))	{
					//$theCode .= "<br/>menuItem:".$t." - ".implode("-",$r);
					//if ($r['uid'] != $uid)
						$newMenuItems[$r['uid']] = $this->getMenuItemTree($r['uid'],($depth-1));
					//$data['pages'][$r['uid']]['move']=$this->pObj->id;
				}
			}
		}
		return $newMenuItems;
	}
		
	function main()
	{
		// Initializes the module. Done in this function because we may need to re-initialize if data is submitted!
		global $SOBE,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Clean up settings:
		$this->pObj->MOD_SETTINGS = t3lib_BEfunc::getModuleData(
		$this->pObj->MOD_MENU,
		t3lib_div::_GP('SET'),
		$this->pObj->MCONF['name']
		);

		if ($GLOBALS['BE_USER']->workspace===0)	{

			$theCode='';

			// check if user has modify permissions to
			$sys_pages = t3lib_div::makeInstance('t3lib_pageSelect');
			$doAlgorithm = t3lib_div::_GP('doAlgorithm');
			$depth = t3lib_div::_GP('depth');
			if ($doAlgorithm&&$depth)	{

				/*$menuItems=array();
				 //if (t3lib_div::inList('title,subtitle,crdate,tstamp',$sortByField))	{
				 $menuItems = $sys_pages->getMenu($this->pObj->id,'uid,pid,title',$sortByField,'',0);
				 } elseif ($sortByField=='REV') {
				 $menuItems = $sys_pages->getMenu($this->pObj->id,'uid,pid,title','sorting','',0);
				 $menuItems = array_reverse($menuItems);
				 }
				 if (count($menuItems))	{
				 $tce = t3lib_div::makeInstance('t3lib_TCEmain');
				 $tce->stripslashes_values=0;
				 $menuItems = array_reverse($menuItems);

				 reset($menuItems);
				 $newMenuItems = array();
				 while(list($t,$r)=each($menuItems))	{
				 $theCode .= "<br/>menuItem:".$t." - ".implode("-",$r);
				 $newMenuItems[] = $r['uid'];
				 //$data['pages'][$r['uid']]['move']=$this->pObj->id;
				 }*/

				$newMenuItems = $this->getMenuItemTree($this->pObj->id,$this->pObj->MOD_SETTINGS['depth']);

				$theCode .= "Tiefe:".$this->pObj->MOD_SETTINGS['depth'];
				//$theCode .= print_r($newMenuItems);	
				
				$pageSelect = t3lib_div::makeInstance('t3lib_pageSelect');
				$row = $pageSelect->getPage($this->pObj->id);
				$theCode .= "<br /> Database:".$row["tx_vtnt_xsize"]."-".$row["tx_vtnt_ysize"]." - min:".min($row["tx_vtnt_xsize"],$row["tx_vtnt_ysize"]);
				$productList = $this->clusterMeAsArray($newMenuItems, round(min($row["tx_vtnt_xsize"],$row["tx_vtnt_ysize"])/2), round(min($row["tx_vtnt_xsize"],$row["tx_vtnt_ysize"])/2), round(min($row["tx_vtnt_xsize"],$row["tx_vtnt_ysize"])/2), 1.5, "", 1, 10);
				//				$productList = $this->clusterMeAsArray($newMenuItems, 75, 75, 75, 1.5, "", 1, 10);

				$data=array();
				foreach ($productList AS $key => $value) {
					$data['pages'][substr($key,0,-1)] = array(
						"tx_vtnt_xpos" 		=> $value["xpos"], 	
						"tx_vtnt_ypos" 		=> $value["ypos"],
						"tx_vtnt_xsize" 	=> $value["xsize"],
						"tx_vtnt_ysize" 	=> $value["ysize"],
						"tx_vtnt_pageobject"=> $value["svg"]
					);
				}

				print_r($data);
				//$theCode.= $this->doTree();
				
				//if (count($productList)) {
					$tce = t3lib_div::makeInstance('t3lib_TCEmain');
					$tce->stripslashes_values=0;
	
					$tce->start($data,array());
					$tce->process_datamap();
					//t3lib_BEfunc::getSetUpdateSignal('updatePageTree');
				//}
				$theCode .= "...got algoritm:".$doAlgorithm;
			}


			$menuItems = $sys_pages->getMenu($this->pObj->id,'*','sorting','',0);
			reset($menuItems);
			$lines=array();
			$lines[]= '<tr>
				<td class="bgColor5"><b>title</b></td>
				'.(t3lib_extMgm::isLoaded('cms')?'<td class="bgColor5"><b>subtitle</b></td>':'').'
				<td class="bgColor5"><b>xpos</b></td>
				<td class="bgColor5"><b>xsize</b></td>
				<td class="bgColor5"><b>ypos</b></td>
				<td class="bgColor5"><b>ysize</b></td>
				<td class="bgColor5"><b>pageObject</b></td>			
				</tr>';

			while(list(,$rec)=each($menuItems))
			{
				$m_perms_clause = $GLOBALS['BE_USER']->getPagePermsClause(2);	// edit permissions for that page!
				$pRec = t3lib_BEfunc::getRecord ('pages',$rec['uid'],'uid',' AND '.$m_perms_clause);
				$lines[]= '<tr><td nowrap="nowrap">'.t3lib_iconWorks::getIconImage('pages',$rec,$GLOBALS['BACK_PATH'],'align="top" '.t3lib_BEfunc::titleAttribForPages($rec)).
				(!is_array($pRec)?$GLOBALS['TBE_TEMPLATE']->rfw('<b>'.$LANG->getLL('wiz_W',1).'</b> '):'').
				htmlspecialchars(t3lib_div::fixed_lgd_cs($rec['title'],$GLOBALS['BE_USER']->uc['titleLen'])).'&nbsp;</td>
					'.(t3lib_extMgm::isLoaded('cms')?'<td nowrap="nowrap">'.htmlspecialchars(t3lib_div::fixed_lgd_cs($rec['subtitle'],$GLOBALS['BE_USER']->uc['titleLen'])).'&nbsp;</td>':'').'
					<td nowrap="nowrap">'.$rec['tx_vtnt_xpos'].'&nbsp;&nbsp;</td>
					<td nowrap="nowrap">'.$rec['tx_vtnt_xsize'].'&nbsp;&nbsp;</td>
					<td nowrap="nowrap">'.$rec['tx_vtnt_ypos'].'&nbsp;&nbsp;</td>
					<td nowrap="nowrap">'.$rec['tx_vtnt_ysize'].'&nbsp;&nbsp;</td>
					<td nowrap="nowrap">'.htmlspecialchars(t3lib_div::fixed_lgd_cs($rec['tx_vtnt_pageobject'],50)).'&nbsp;&nbsp;</td>					
					</tr>';
			}
			$theCode.= '<b>'.$LANG->getLL('wiz_currentPageOrder',1).':</b><br /><br />
			<table border="0" cellpadding="0" cellspacing="0">'.implode('',$lines).'</table><br />';

			// CSH:
			$theCode.= t3lib_BEfunc::cshItem('_MOD_web_func', 'tx_vtnt_modfunc1', $GLOBALS['BACK_PATH'],'<br/>|');

			$out=$this->pObj->doc->section($LANG->getLL('wiz_sort'),$theCode,0,1);
		} else {
			$out=$this->pObj->doc->section($LANG->getLL('wiz_sort'),'Sorry, this function is not available in the current draft workspace!',0,1,1);
		}

		$theOutput.=$this->pObj->doc->spacer(5);
		$theOutput.=$this->pObj->doc->section($LANG->getLL("title"),"Erstelle eine Selection-Box, aus der man die Technik auswhlen kann...",0,1); $menu=array();

		$menu[]=t3lib_BEfunc::getFuncCheck(
		$this->pObj->id,
			"SET[tx_vtnt_modfunc1_check]",
		$this->pObj->MOD_SETTINGS["tx_vtnt_modfunc1_check"]).$LANG->getLL("checklabel");


		// Depth selector:
		$depthSelectorBox = t3lib_BEfunc::getFuncMenu(
		$this->pObj->id,'SET[depth]',
		$this->pObj->MOD_SETTINGS['depth'],
		$this->pObj->MOD_MENU['depth'],'index.php');


		$algorithmSelectorBox = t3lib_BEfunc::getFuncMenu(
		$this->pObj->id,
			"SET[tx_vtnt_modfunc1_algorithm]",
		$this->pObj->MOD_SETTINGS['tx_vtnt_modfunc1_algorithm'],
		$this->pObj->MOD_MENU['tx_vtnt_modfunc1_algorithm']
		);

		$theOutput.="output".$this->pObj->MOD_SETTINGS['tx_vtnt_modfunc1_algorithm'];

		$theOutput.=$depthSelectorBox;
		$theOutput.= '<a href="'.htmlspecialchars('index.php?id='.$GLOBALS['SOBE']->id.'&doAlgorithm='.$this->pObj->MOD_SETTINGS['tx_vtnt_modfunc1_algorithm']).'&depth='.$this->pObj->MOD_SETTINGS['depth'].'" onclick="return confirm('.$GLOBALS['LANG']->JScharCode($GLOBALS['LANG']->getLL('doAlgorithm_hint')).')">'."Landkarte sortieren!".'</a>';
		$theOutput.=$algorithmSelectorBox;
		$theOutput.=$this->pObj->doc->spacer(5);
		$theOutput.=$this->pObj->doc->section("Menu",implode(" - ",$menu),0,1);

		return $theCode.$theOutput;
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/temp/modfunc1/class.tx_temp_modfunc1.php"])
{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/temp/modfunc1/class.tx_temp_modfunc1.php"]);
}
?>