<?php

// Exit, if script is called directly (must be included via eID in index_ts.php)
if (!defined ('PATH_typo3conf')) die ('Could not access this script directly!');

require_once('class.tx_vtnt_db.php');
require_once('class.tx_vtnt_lib.php');
require_once('func.bool.php');


// Initialize FE user object:
$feUserObj = tslib_eidtools::initFeUser();

// Connect to database:
tslib_eidtools::connectDB();
//$db = new tx_vtnt_db();
$db = t3lib_div::makeInstance('tx_vtnt_db');

$action = 	t3lib_div::_GET('action');

if ($action == "addUser") {
	$uid = 		intval(t3lib_div::_GET('uid'));
	//echo "userId".intval(t3lib_div::_GET('uid'));
	$nick = 	t3lib_div::_GET('nick');
 	$x = 		intval(t3lib_div::_GET('x'));
	$y = 		intval(t3lib_div::_GET('y'));
	$loud = 	intval(t3lib_div::_GET('loudness'));
	$active = 	bool(t3lib_div::_GET('active'));
	$name = 	t3lib_div::_GET('name');
	$company = 	t3lib_div::_GET('company');
	$position = t3lib_div::_GET('position');
	$pic = 		t3lib_div::_GET('pic');	 							
	$uid = $db->addUser($uid,"", $nick,$x,$y,$loud,$active,$name,$company,$position,$pic);
	$ajax_return_data = t3lib_div::array2xml(array('uid'=>$uid));
}
elseif ($action =="ping") {
	$timestamp 	= 	t3lib_div::_GET('timestamp');
	$uid		= 	t3lib_div::_GET('uid');
	$userArray = $db->ping($timestamp,$uid);
	$ajax_return_data = t3lib_div::array2xml($userArray);
}
elseif ($action =="setTextLine") {
	$sid 	= 	t3lib_div::_GET('sId');
	$x		= 	t3lib_div::_GET('x');
	$y		= 	t3lib_div::_GET('y');
	$loud		= 	t3lib_div::_GET('loudness');
	$text		= 	t3lib_div::_GET('text');    	
	$userArray = $db->setTextLine($sid,$x, $y, $loud, $text);
	$ajax_return_data = t3lib_div::array2xml(array('uid'=>$userArray));
}
elseif ($action =="updateChat") {
	
	$textX 		= 	t3lib_div::_GET('textX');
	$textY 		= 	t3lib_div::_GET('textY');
	$movingDate	= 	t3lib_div::_GET('movingDate');
	$lastTMesg  = 	t3lib_div::_GET('lastTextMessage');
	
	$chatArray = $db->updateChat($textX,$textY,$movingDate, $lastTMesg);
	$ajax_return_data = t3lib_div::array2xml($chatArray);
}
elseif ($action =="pageId") {

	$xPos 		= 	t3lib_div::_GET('x');
	$yPos 		= 	t3lib_div::_GET('y');
	
	$pid = $db->getPageId($xPos, $yPos);;
	$ajax_return_data = t3lib_div::array2xml(array("page" => $pid));
}
elseif ($action =="userDetails") {

	$uid 		= 	t3lib_div::_GET('uid');
	
	$pid = $db->getUserData($uid);
	$ajax_return_data = t3lib_div::array2xml(array("user" => $pid));
}
elseif ($action =="getProductMap") {
	$pid =  intval(t3lib_div::_GET('uid'));
	$xMin = intval(t3lib_div::_GET('xmin'));
	$xMax = intval(t3lib_div::_GET('xmax'));
	$yMin = intval(t3lib_div::_GET('ymin'));
	$yMax = intval(t3lib_div::_GET('ymax'));
	$iter = intval(t3lib_div::_GET('iter'));

	$mapArray = $db->getMapArea($xMin, $xMax, $yMin, $yMax, $iter);
	$ajax_return_data = htmlspecialchars_decode(t3lib_div::array2xml(array('map' => $mapArray)));
	
}

header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . gmdate( "D, d M Y H:i:s" ) . 'GMT');
header('Cache-Control: no-cache, must-revalidate');
header('Pragma: no-cache');
header('Content-Length: '.strlen($ajax_return_data));
header('Content-Type: application/xml; charset=utf-8');
echo $ajax_return_data;
exit;

?>
