<?php

//require_once(PATH_t3lib.'class.t3lib_div.php');



class tx_vtnt_db {

	var $db;
	var $extCONF;

	/*static final $maxSessionLifetime = 5; */
	const ZOOMLEVEL_1 = 1.01;
	const ZOOMLEVEL_2 = 1.2;
	const ZOOMLEVEL_3 = 1.5;
	const ZOOMLEVEL_4 = 2.0;


	function tx_vtnt_db() {
		$this->db = $GLOBALS['TYPO3_DB'];
		$this->extCONF = tx_vtnt_lib::getExtConf();
	}

	function getExtConf() {
		return unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['vtnt']);
	}

	function setDebug($debug) {
		$this->db->debugOutput = $debug;
		$this->db->store_lastBuiltQuery = $debug;
	}

	/* vtnt-old start */

	/**
	 * deleteAllUser
	 * deletes <ul><li>all sessions</li><li>all chatlogs</li></ul>
	 *
	 */
	function deleteAllUser() {

		//echo "DELETE ALL USERS";
		$res = $this->db->exec_DELETEquery('tx_vtnt_sessions', '');
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

		$res = $this->db->exec_DELETEquery('tx_vtnt_chatlog', '');
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
	}

	/**
	 * All user not having done any action for longer than x minutes will be deleted.
	 *
	 * @param unknown_type $minutes
	 * @return unknown
	 */
	private function _deleteUserWithNoActionSinceMinutes( $minutes = 5) {

		//echo "delete(OLD USERS)";
		$res = $this->db->exec_DELETEquery('tx_vtnt_sessions', "lastseen <= ".($this->getUnixTimestamp() - ($minutes*60)));
		//   echo $this->db->DELETEquery('tx_vtnt_sessions', "lastseen <= ".($this->getUnixTimestamp() - ($minutes*60)));
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
		return $res;
	}


	/**
	 * addUser
	 *
	 * @TODO: SessionId-Handling ueberarbeiten
	 * @param id String is a temporarily one
	 */
	function addUser($id, $sessionId, $nick, $xpos, $ypos, $loudness, $active, $name="", $company="", $cposition="", $picurl ="") {

		$this->_deleteUserWithNoActionSinceMinutes(5);

		$newID;
		$whereClause = "uid=$id ";
		if (!empty($sessionId) && $sessionId!="") $whereClause .= "OR sessionId='$sessionId'";
				
		$res = $this->db->exec_SELECTquery(
				'count(uid) as existing', 
				'tx_vtnt_sessions', 
				$whereClause
		);

		//echo
		$this->db->SELECTquery(
				'count(uid) as existing', 
				'tx_vtnt_sessions', 
				$whereClause);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

		$tmp = $this->db->sql_fetch_assoc($res);
		$tmp = $tmp["existing"];

		$timestamp = $this->getUnixTimestamp();

		$queryFields = array(
        "nick" 		=> htmlSpecialChars($nick),
  		"xpos" 		=> htmlSpecialChars($xpos),
  		"ypos" 		=> htmlSpecialChars($ypos),
  		"loudness"	=> htmlSpecialChars($loudness),
  		"lastseen"	=> $timestamp,
  		"chatter"	=> (($active == true)||$active == 1)?'1':'0',
  		"lastaction"=> $timestamp,
  		"name"		=> $name,
  		"company"	=> htmlSpecialChars($company),
  		"cposition"	=> htmlSpecialChars($cposition),
  		"picurl"	=> $pictureurl,
  		"lastmoved"	=>  $timestamp
		);
		
		if (!empty($sessionId) && $sessionId!="") $queryFields["sessionId"] = $sessionId;

		//echo "-".$tmp;
		if ($tmp == 0) {
			$res = $this->db->exec_INSERTquery(
			   	'tx_vtnt_sessions', 
			$queryFields
			);
			//echo
			$this->db->INSERTquery(
			   	'tx_vtnt_sessions', 
			$queryFields
			);
			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

			$res = $this->db->exec_SELECTquery(
			   	'uid',
           		'tx_vtnt_sessions',
           		'nick = \''.$queryFields['nick'].'\' AND xpos='.$queryFields['xpos'].' AND ypos='.$queryFields['ypos']
			);
			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

			$newID = $this->db->sql_fetch_assoc($res);
			$newID = $newID['uid'];
			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

			/*
			 $objResponse->addScript('if (myModel.getUserById("'.$id.'")) myModel.getUserById("'.$id.'").setId("'.$newID.'");'
			 .' else oLogger.error("User-ID not changed, Leerlauf '.$id.'-'.$newID.'");');
			 $objResponse->addScript('notifyObservers(myModel.oObjects2BeNotifiedFor);');
			 */
		}
		else
		{
			$res = $this->db->exec_UPDATEquery(
				'tx_vtnt_sessions', 
  				'uid='.$id,
				$queryFields
			);
			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
		}
		return $newID;
	}

	function _setLastAction($id) {
		$res = $this->db->exec_UPDATEquery(
				'tx_vtnt_sessions', 
  				'uid='.$id,
		array("lastaction"=>$this->getUnixTimestamp(), "lastseen"=>$this->getUnixTimestamp())
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
	}

	function _setLastSeen($id) {
		$res = $this->db->exec_UPDATEquery(
				'tx_vtnt_sessions', 
  				'uid='.$id,
		array("lastseen"=>$this->getUnixTimestamp())
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
	}

	function setTextLine($id, $x, $y, $loudness, $text) {

		$text = htmlSpecialChars($text);
		$this->_setLastAction($id);

		$queryFields = array(
 		"sid"	=> $id,
 		"entry"	=> $text,
 		"xpos"	=> $x,
 		"ypos"	=> $y,
 		"loudness" => $loudness,	
 		"tstamp" => $this->getUnixTimestamp()
		);

		$res = $this->db->exec_INSERTquery(
				'tx_vtnt_chatlog', 
		$queryFields
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

		$res = $this->db->exec_SELECTquery(
 		    'uid',
				'tx_vtnt_chatlog', 
 		    "sid ='$id' AND xpos='$x' AND ypos='$y' ",'','tstamp DESC'
 		    );
 		    if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
 		    //echo "textId".$this->db->sql_fetch_assoc($res);;
 		    $newId = $this->db->sql_fetch_assoc($res);
 		    $newId = $newId['uid'];
 		    //echo "TextLineId is:".$newId;
 		    return $newId;
	}


	/**
	 * updateChat
	 *
	 * fetches the textmessages belonging to a special location. Wether a message
	 * is fetched depends on the distance between the message and the user
	 * and wether the message was send before the user moved to
	 * that position. The Messages will be selected through a rectangle.
	 *
	 * @param Int - X of window-position
	 * @param Int - Y of window-position
	 * @param Date - Date of the last Message to be selected
	 * @param Int - first ID of Message28.02.2007 19:12:37
	 * @return xajax-Object (addAssign + Script-oLogger.debugssage)
	 */
	function updateChat($x1,$y1, $lastMessageDate, $newLastMessage = 0, $uid = null){
		global $chatPing;
		$i = 0;

		if (isset($uid)&& $uid!="undefined") {
			$this->_setLastSeen($uid);
		}

		$timestamp = $this->getUnixTimestamp();

		if (1==1) {

			/**
			 * @param se -  der Aussprechende
			 * @param se2 - der Hoerer
			 */

			$selectField = "cl.uid as id, ".
            "cl.sid as sid, ".
            "cl.xpos as xpos, ".
            "cl.ypos as ypos, ".
            "cl.loudness as loudness, ".
            "cl.entry as text, ".
            "cl.tstamp as timestamp, ".
            "se.nick AS snick";

			$fromField = "tx_vtnt_chatlog AS cl, tx_vtnt_sessions AS se ";

			$whereField = "se.uid=cl.sid ".
                  "AND ((cl.xpos-cl.loudness)<='$x1' AND (cl.xpos+cl.loudness)>='$x1') ".
                  "AND ((cl.ypos-cl.loudness)<='$y1' AND (cl.ypos+cl.loudness)>='$y1') ".  			
            			"AND cl.tstamp >= '$lastMessageDate' ".
            			"AND cl.uid > '$newLastMessage' ";

			$res = $this->db->exec_SELECTquery(
			$selectField,
			$fromField,
			$whereField,
			"",
			"cl.tstamp DESC"
			);

			/*echo $this->db->SELECTquery(
			 $selectField,
			 $fromField,
			 $whereField,
			 "",
			 "cl.tstamp DESC"
			 );
			 */
			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery)."SELECT ".$selectField." FROM ".$fromField." WHERE ".$whereField;

			$chatUser = "";
			$chatArray = array();
			while ($row = $this->db->sql_fetch_assoc($res)) {

				$chatArray[i] = array(
					"id"=>$row['id'], 
					"sid" => $row['sid'], 
					"xpos" =>$row['xpos'],
            		"ypos"=> $row['ypos'], 
            		"loudness"=>$row['loudness'],
            		"text"=>$row['text'],
            		"timestamp" => $row['timestamp']
				);

				$i++;
				//$newLastMessage = $row['id'];
			}


		}
		$resultArray = array("time"=>$timestamp, "chat" => $chatArray);
		//  $objResponse->addScript("window.location.href=\"http://wum16052.mms-dresden.telekom.de\";");

		//  $objResponse->addScript("window.setTimeout(\"xajax_updateChat(myAvatar, active, lastMessage)\", $chatPing);");
		return $resultArray;
	}

	function getUnixTimestamp() {
		$res = $this->db->sql_query('SELECT UNIX_TIMESTAMP(CURRENT_TIMESTAMP) AS CURTS');

		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
		$tmpDate = $this->db->sql_fetch_assoc($res);
		return $tmpDate["CURTS"];

	}

	function setNewPosition($id, $xpos, $ypos, $loudness="", $nick="", $active="", $name="", $company="", $cposition="", $picUrl="") {

		$nick = htmlSpecialChars($nick);
		$name = htmlSpecialChars($name);
		$company = htmlSpecialChars($company);
		$cposition = htmlSpecialChars($cposition);

		$res = $this->db->exec_SELECTquery(
				'xpos, ypos',
        'tx_vtnt_sessions', 
				'uid='.$id
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
		$row = $this->db->sql_fetch_assoc($result);

		$updateFields = array("xpos" => $xpos,
                        "ypos" => $ypos);

		if (!$loudness=="")   $updateFields["loudness"]=$loudness;
		if (!$nick=="")       $updateFields["nick"]=$nick;
		if (!$name=="")       $updateFields["name"]=$name;
		if (!$company=="")     $updateFields["company"]=$company;
		if (!$cposition=="")  $updateFields["cposition"]=$cposition;
		if (!$picUrl=="")     $updateFields["picurl"]=$picUrl;
		if (!$active=="")     $updateFields["chatter"]=$active;
		if ($xpos!=$row['xpos']||$ypos!=$row['ypos']) $updateFields["lastmoved"]=$this->getUnixTimestamp();

		$res = $this->db->exec_UPDATEquery(
  				'tx_vtnt_sessions',
		$updateFields,
  				'uid='.$id 
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);


		// Set a cookie with the actual data
		$cookieTime = time()+36000;
		setcookie("vtnt[xpos]",$xpos, $cookieTime);
		setcookie("vtnt[loudness]",$loudness, $cookieTime);
		setcookie("vtnt[ypos]",$ypos, $cookieTime);
		setcookie("vtnt[nick]",$nick, $cookieTime);
		setcookie("vtnt[active]", $active, $cookieTime);
		setcookie("vtnt[name]", $name, $cookieTime);
		setcookie("vtnt[company]", $company, $cookieTime);
		setcookie("vtnt[cposition]", $cposition, $cookieTime);
		setcookie("vtnt[picurl]", $picUrl, $cookieTime);
	}

	function getUserData($id) {
		global $noPhoto;
		
		$res = $this->db->exec_SELECTquery(
				'*, (90 - TIMESTAMPDIFF(SECOND,vtnt_user.lastaction,'.$this->getUnixTimestamp().')) AS laseconds',
        		'tx_vtnt_sessions AS vtnt_user, fe_sessions, fe_users', 
				'vtnt_user.uid='.$id.' AND vtnt_user.sessionid=fe_sessions.ses_id AND fe_sessions.ses_userid= fe_users.uid'
		);

		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
		$row = $this->db->sql_fetch_assoc($res);

/*		foreach ( $row AS $key => $value )
			echo "\n $key -> $value";
	*/	
		$myNick = $row['username'];
		$myLastSeen = $row['laseconds'];
		$myName = $row['name'];
		$myPosition = $row['company'];
		$myBusiness = $row['title'];
		$myImage = $row['image'];

		if ($myImage == ""||$myImage == "undefined") $myImage = $noPhoto;
		if ($myName == "")  $myName =  "<i>unbekannt</i>";
		if ($myPosition == "") $myPosition = "<i>unbekannt</i>";
		if ($myBusiness == "") $myBusiness = "<i>unbekannt</i>";

		/*$myDemoText = "<div id='".$id."Profile'><img src='$myImage' height='60' /><dl><dt>Nickname</dt><dd>$myNick</dd>"
		."<dt>Name</dt><dd>$myName</dd>"
		."<dt>Business</dt><dd>$myBusiness</dd>"
		."<dt>Position</dt><dd>$myPosition</dd>"
		."<dt>lastSeen</dt><dd>$myLastSeen</dd>"
		."</dl></div>";*/

		$userData = array(
					"uid" 		=> $id,
					"img" 		=> $myImage,
					"nick"  	=> $myNick,
					"name" 		=> $myName,
					"business"	=> $myBusiness,
					"position"	=> $myPosition,
					"lastseen"	=> $myLastSeen
		);
		return $userData;
	}

	function ping($lastseen, $id = null ) {
		global $members, $visualPing;

		$chatUser= "";
		$userArray = array();
		$timeStamp = $this->getUnixTimestamp();

		$res = $this->db->exec_SELECTquery(
				'*, (90-('.$timeStamp.' - vtnt_user.lastaction)) AS laseconds, vtnt_user.uid AS newuid ',
        		'tx_vtnt_sessions AS vtnt_user LEFT OUTER JOIN fe_sessions ON vtnt_user.sessionid=fe_sessions.ses_id '.
				'LEFT OUTER JOIN fe_users ON fe_sessions.ses_userid= fe_users.uid', 
				'vtnt_user.lastseen>'.$lastseen
			);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

		$i = 0;
		while ($row = $this->db->sql_fetch_assoc($res)) {
			if ($row['laseconds'] < 0) $row['laseconds']=0;
			if (!isset($row['email'])) $row['email']="";

			$userArray[$i] = array(
								"id" 		=> $row['newuid'],
								"nick"		=> ($row['username']!="")?$row['username']:"Gast",
								"xpos"		=> $row['xpos'],
								"ypos"		=> $row['ypos'],
								"loudness"	=> $row['loudness'],
								"chatter"	=> $row['chatter'],
								"laseconds"	=> $row['laseconds'],
								"lmseconds" => $row['lastseen'],
								"lastmovedseconds"=>$row['lastmoved'],
								"name"		=> ($row['name']!="")?$row['name']:"none",
								"company"	=> ($row['company']!="")?$row['company']:"none",
								"cposition" => ($row['title']!="")?$row['title']:"none",
								"email" 	=> ($row['email']!="")?$row['email']:"none"
								);

								if ($row['image']!="") $userArray[$i]["image"]="uploads/pics/".$row['image'];
								
								$i++;
		}

		if (isset($id)&& $id!="undefined") {
			$this->_setLastSeen($id);
		}

		return array("user"=>$userArray,"time"=>$timeStamp);
	}

	/**
	 * Returns the userData for the given userId
	 *
	 * @param int $uId
	 * @return array $user - associative array with the keys <ul>
	 * 						<li>id</li><li>nick</li><li>xpos</li><li>ypos</li><li>loudness</li>
	 * 						<li>chatter</li><li>laseconds</li><li>lmseconds</li><li>name</li>
	 * 						<li>company</li><li>cposition</li><li>email</li></ul>
	 **/
	function getSessionData($uId) {
		$res = $this->db->exec_SELECTquery(
         "*, (90 - (".$timeStamp."-lastaction)) AS laseconds",
          'tx_vtnt_sessions', 
  		  "uid=$uId"
		);

		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

		$row = $this->db->sql_fetch_assoc($res);
		if ($row['laseconds'] < 0) $row['laseconds']=0;
		if (!isset($row['email'])) $row['email']="";

		$user = array(
						"id" 		=> $row['uid'],
						"nick"		=> $row['nick'],
						"xpos"		=> $row['xpos'],
						"ypos"		=> $row['ypos'],
						"loudness"	=> $row['loudness'],
						"chatter"	=> $row['chatter'],
						"laseconds"	=> $row['laseconds'],
						"lmseconds" => $row['lastseen'],
						"lastmovedseconds"=>$row['lastmoved'],
						"name"		=> ($row['name']!="")?$row['name']:"none",
						"company"	=> ($row['company']!="")?$row['company']:"none",
						"cposition" => ($row['cposition']!="")?$row['cposition']:"none",
						"email" 	=> ($row['email']!="")?$row['email']:"none"
						);
						return $user;
	}

	function getMapData($sParent, $iMaxIteration) {
		global $aProducts;
		/*		$objResponse = new xajaxResponse();
		 $objResponse->addScript(clusterMe($aProducts, 0, 0, 600, 1.5, $sParent, 1, $iMaxIteration));
		 return $objResponse;*/
	}

	/**
	 * Enter description here...
	 *
	 * @param int $xPos position on x-axe
	 * @param int $yPos position on y-axe
	 * @param int $parent - parent element, because of rekursive usage
	 */
	function getPageId($xPos, $yPos, $parent = null) {
		$selectQuery = "uid, pid, title, tx_vtnt_pageobject, tx_vtnt_pageobject_image, tx_vtnt_xpos, tx_vtnt_xsize, tx_vtnt_ypos, tx_vtnt_ysize";
		$fromQuery = 'pages';
		$whereQuery = "tx_vtnt_xpos<=$xPos AND (tx_vtnt_xpos + tx_vtnt_xsize)>=$xPos ".
					 "AND tx_vtnt_ypos<=$yPos AND (tx_vtnt_ypos + tx_vtnt_ysize)>=$yPos";

		if ($parent != null )
		{
			$whereQuery .= " AND pid=$parent";
		}

		$res = $this->db->exec_SELECTquery(
		$selectQuery,
		$fromQuery,
		$whereQuery
		);

		//echo
		$this->db->SELECTquery(
		$selectQuery,
		$fromQuery,
		$whereQuery
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery)."->".$selectQuery.$fromQuery.$whereQuery;

		$cachedPId = null;
		while ($row = $this->db->sql_fetch_assoc($res)) {
			$cachedPId = $row["uid"];
			$pId = $this->getPageId(
			$xPos - $row["tx_vtnt_xpos"],
			$yPos - $row["tx_vtnt_ypos"],
			$row["uid"]);
			if ($pId != null )
			{
				return $pId;
			};
		}
		return $cachedPId;
	}

	/**
	 * Zeige alle Produkte, welche auf der Gesamtlandkarte innerhalb des markierten Fensters sichtbar sind.
	 * Da Produkte iterativ aufgebaut sind, also nur ihre Position innerhalb des Mutterblocks kennen, muss
	 * die SQL-Anfrage iterativ durchgefhrt werden.
	 **/
	function getMapArea($xMin, $xMax, $yMin, $yMax, $maxIteration = null, $pId = null, $iIteration = 0) {

		$mapArray = array();
		// falls der ZoomLevel und die Iterationsebene passen
		if ( $iIteration <= $maxIteration )
		{
			$selectQuery= "uid, pid, title, tx_vtnt_pageobject, tx_vtnt_pageobject_image, tx_vtnt_xpos, tx_vtnt_xsize, tx_vtnt_ypos, tx_vtnt_ysize";
			$fromQuery= 'pages';
			$whereQuery = " deleted = 0 AND hidden = 0 AND";
			if ($pId != null)
			$whereQuery .= " pid=$pId AND";
			//$whereQuery .= "tx_vtnt_xsize>0 AND tx_vtnt_ysize>0 AND";
			$whereQuery .= " ((tx_vtnt_xpos>=$xMin AND tx_vtnt_xpos<=$xMax) ".
					 "OR ((tx_vtnt_xpos+tx_vtnt_xsize)>=$xMin AND (tx_vtnt_xpos + tx_vtnt_xsize)<=$xMax))".
					 "AND ((tx_vtnt_ypos>=$yMin AND tx_vtnt_ypos<=$yMax) ".
					 "OR ((tx_vtnt_ypos+tx_vtnt_ysize)>=$yMin AND (tx_vtnt_ypos + tx_vtnt_ysize)<=$yMax))";

			$res = $this->db->exec_SELECTquery(
			$selectQuery,
			$fromQuery,
			$whereQuery,"","pid"
			);

			//echo
			$this->db->SELECTquery(
			$selectQuery,
			$fromQuery,
			$whereQuery,"","pid"
			);
			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery)."->".$selectQuery.$fromQuery.$whereQuery;

			while ($row = $this->db->sql_fetch_assoc($res)) {
				$mapArray[] = array(
								"id" 		   => $row['uid'],
								"name"		 => $this->getCleaned($row['title']),
								"pid" 		 => $row['pid'],								
								"svg"		   => $row['tx_vtnt_pageobject'],
								"picurl"   => $row['tx_vtnt_pageobject_image'],
								"xpos"	   => $row['tx_vtnt_xpos'],
								"xsize"	   => $row['tx_vtnt_xsize'],
								"ypos"	   => $row['tx_vtnt_ypos'],
								"ysize"    => $row['tx_vtnt_ysize'],
				);
				array_merge($mapArray,
				$this->getMapArea(
				$xMin-$row['tx_vtnt_xpos'],
				$xMax-$row['tx_vtnt_xpos'],
				$yMin-$row['tx_vtnt_ypos'],
				$yMax-$row['tx_vtnt_xpos'],
				$zoom,
				$row['uid'],
				++$iIteration
				)
				);
			}
		}
		return $mapArray;
	}

	function getChildMapArea($pId) {
		$selectQuery= "uid, pid, title, tx_vtnt_pageobject, tx_vtnt_pageobject_image, tx_vtnt_xpos, tx_vtnt_xsize, tx_vtnt_ypos, tx_vtnt_ysize";
		$fromQuery= 'pages';
		$whereQuery= "pid=$pId AND tx_vtnt_xsize >0 AND tx_vtnt_ysize > 0";

		$res = $this->db->exec_SELECTquery(
		$selectQuery,
		$fromQuery,
		$whereQuery
		);

		//echo
		$this->db->SELECTquery(
		$selectQuery,
		$fromQuery,
		$whereQuery
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery)."->".$selectQuery.$fromQuery.$whereQuery;

		$mapArray = array();
		while ($row = $this->db->sql_fetch_assoc($res)) {
			$mapArray[] = array(
								"id" 		   => $row['uid'],
								"name"		 => $this->getCleaned($row['title']),
								"pid" 		 => $row['pid'],								
								"svg"		=> $row['tx_vtnt_pageobject'],
								"picurl"   => $row['tx_vtnt_pageobject_image'],
								"xpos"	   => $row['tx_vtnt_xpos'],
								"xsize"	   => $row['tx_vtnt_xsize'],
								"ypos"	   => $row['tx_vtnt_ypos'],
								"ysize"    => $row['tx_vtnt_ysize'],
			);
			$mapArray = array_merge($mapArray, $this->getChildMapArea($row['uid']));

		}
		return $mapArray;
	}

	/**
	 * returns recursively found map-borders.
	 *
	 * @return array(xpos, ypos, xsize,ysize)
	 */
	function getMapCoordinatesForPage($pageId) {
		$pid = $pageId;
		$i = 0;
		while ($pid != 0) {
			$selectQuery= "tx_vtnt_xpos, tx_vtnt_xsize, tx_vtnt_ypos, tx_vtnt_ysize, pid";
			$fromQuery= 'pages';
			$whereQuery= "uid=$pid";

			$res = $this->db->exec_SELECTquery(
			$selectQuery,
			$fromQuery,
			$whereQuery
			);

			if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery)."->".$selectQuery.$fromQuery.$whereQuery;

			$row[$i] = $this->db->sql_fetch_assoc($res);
			$pid = $row[$i]['pid'];
			$i++;
		};

		$tx_vtnt_xpos = 0;
		$tx_vtnt_ypos = 0;
		foreach ($row AS $item) {
			$tx_vtnt_xpos += $item['tx_vtnt_xpos'];
			$tx_vtnt_ypos += $item['tx_vtnt_ypos'];
		}

		return array(
            "xpos"=>$tx_vtnt_xpos, 
            "ypos"=>$tx_vtnt_ypos, 
            "xsize" =>$row[0]["tx_vtnt_xsize"], 
            "ysize"=>$row[0]["tx_vtnt_ysize"] );
			
	}

	function getSingleUserBySessionId($sessionId) {

	$res = $this->db->exec_SELECTquery(
         "*",
          'tx_vtnt_sessions', 
  		  "sessionid = '$sessionId'"
		);

		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);

		$row = $this->db->sql_fetch_assoc($res);
		if ($row['laseconds'] < 0) $row['laseconds']=0;
		if (!isset($row['email'])) $row['email']="";

		$user = array(
								"id" 		=> $row['uid'],
								"nick"		=> $row['nick'],
								"xpos"		=> $row['xpos'],
								"ypos"		=> $row['ypos'],
								"loudness"	=> $row['loudness'],
								"chatter"	=> $row['chatter'],
								"laseconds"	=> $row['laseconds'],
								"lmseconds" => $row['lastseen'],
								"lastmovedseconds"=>$row['lastmoved'],
								"name"		=> ($row['name']!="")?$row['name']:"none",
								"company"	=> ($row['company']!="")?$row['company']:"none",
								"cposition" => ($row['cposition']!="")?$row['cposition']:"none",
								"email" 	=> ($row['email']!="")?$row['email']:"none"
		);
		return $user;
	}

	/**
	 * Sets the actual page-visitor on an imaginary position within the map and
	 * shows him that way to other visitors. If the actual user-position fits into 
	 * the coordinates, it wont be touched.
	 *
	 * @author: LER
	 * @param sessionId Session-Id of Typo3-Visitor
	 * @param pageId actual page being visited by customer
	 */
	function setVisitor($sessionId, $pageId) {

		$this->_deleteUserWithNoActionSinceMinutes(5);
		$timestamp = $this->getUnixTimestamp();

		$mapFieldData = $this->getMapCoordinatesForPage($pageId);
		$userData = $this->getSingleUserBySessionId($sessionId);
		
		//echo "(".$mapFieldData["xpos"].",".$mapFieldData["ypos"].") -> (".$userData["xpos"].",".$userData["ypos"].")-> (".($mapFieldData["xpos"]+$mapFieldData["xsize"]).",".($mapFieldData["ypos"]+$mapFieldData["ysize"]).")";
		if ($userData["xpos"]>$mapFieldData["xpos"]
			&&$userData["xpos"]< $mapFieldData["xpos"]+$mapFieldData["xsize"]
			&&$userData["ypos"]>$mapFieldData["ypos"]
			&&$userData["ypos"]< $mapFieldData["ypos"]+$mapFieldData["ysize"]) 
			{
				//echo "keeping old";
				$newXPos = 	$userData["xpos"];
				$newYPos =  $userData["ypos"];
			} else {
				//echo "new one";
				$newXPos = $mapFieldData["xpos"]+rand(1,$mapFieldData["xsize"]);
				$newYPos = $mapFieldData["ypos"]+rand(1,$mapFieldData["ysize"]);
			}
		
		$updateQuery= array(
                    "pid"       => $pageId,
                    "xpos"      => $newXPos, 
                    "ypos"      => $newYPos,
                    "lastseen"  => $timestamp,
                    "lastmoved" => $timestamp
		);

		$fromQuery= 'tx_vtnt_sessions';
		$whereQuery= "sessionid='$sessionId'";

		$res = $this->db->exec_UPDATEquery(
		$fromQuery,
		$whereQuery,
		$updateQuery
		);

		//echo
		$this->db->UPDATEquery(
		$fromQuery,
		$whereQuery,
		$updateQuery
		);



		// falls Nutzer noch nicht in Datenbank existiert
		// echo $this->db->sql_affected_rows();
		if ($this->db->sql_affected_rows() == 0) {
			//echo "adding new user";
			return $this->addUser(
			0,
			$sessionId,
            "testnutzer",
			$mapFieldData["xpos"]+rand(0,$mapFieldData["xsize"]),
			$mapFieldData["ypos"]+rand(0,$mapFieldData["ysize"]),
			40,
			false);
		} else {
			return $this->getUIdForSessionId($sessionId);
		}

	}

	/**
	 * Returns the User-Id for a given sessionId
	 *
	 * @param String $sessionId
	 * @return int userId
	 */
	function getUIdForSessionId($sessionId) {
		$selectQuery= "uid";
		$fromQuery= 'tx_vtnt_sessions';
		$whereQuery= "sessionid='$sessionId'";

		$res = $this->db->exec_SELECTquery(
		$selectQuery,
		$fromQuery,
		$whereQuery
		);
		if(!$res) print '#'.__LINE__.' - '.($this->db->debug_lastBuiltQuery);
		$tmpUId = $this->db->sql_fetch_assoc($res);
		return $tmpUId["uid"];
	}

	function testMe() {
		return "<circle cx='20' cy='20' r='50' />";
	}

	function getPageImage($uid) {
		$res = $this->db->exec_SELECTquery(
         "tx_vtnt_pageobject_image AS img",
          'pages', 
  		  'uid='.$uid
		);
		$resultSet = $this->db->sql_fetch_assoc($res);
		return $resultSet["img"];
	}

	function getCleaned($text){
		$text = htmlspecialchars($text); //,ENT_NOQUOTES,'UTF-8');
		/*
		$text = eregi_replace("ü","ue",$text);
		$text = eregi_replace("ä","ae",$text);
		$text = eregi_replace("","oe",$text);
		$text = eregi_replace("&uuml;","ue",$text);
		$text = eregi_replace("&auml;","ae",$text);
		$text = eregi_replace("&ouml;","oe",$text);
		$text = eregi_replace("&szlig;","ss",$text);
		$text = eregi_replace("&nsbp;","_",$text);
		$text = eregi_replace("","ue",$text);
		$text = eregi_replace("","ae",$text);
		$text = eregi_replace("","oe",$text);
		$text = eregi_replace("","ss",$text);
		$text = eregi_replace(" ","_",$text);
		*/
		return $text;
	}


}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/vtnt/pi1/class.tx_vtnt_db.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/vtnt/pi1/class.tx_vtnt_db.php']);
}
?>
