    //initialize the logger  with your category 
     var oLogger = Log4js.getLogger("vtntTest"); 

     //set the level of logging 
     oLogger.setLevel(Log4js.Level.INFO); 
      //set the Appender to write the log to 
     //oLogger.addAppender(new ConsoleAppender(oLogger, true)); 


     // some facts
   	var svgNS = 'http://www.w3.org/2000/svg';
    var xhtmlNS = 'http://www.w3.org/1999/xhtml';
  	var xlinkNS = 'http://www.w3.org/1999/xlink';
    var iAktiveSeconds = 120;

	  function getPageSize(){
	 	
	 	var xScroll, yScroll;
	 	
	 	if (window.innerHeight && window.scrollMaxY) {	
	 		xScroll = document.body.scrollWidth;
	 		yScroll = window.innerHeight + window.scrollMaxY;
	 	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
	 		xScroll = document.body.scrollWidth;
	 		yScroll = document.body.scrollHeight;
	 	} else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
	 		xScroll = document.body.offsetWidth;
	 		yScroll = document.body.offsetHeight;
	 	}
	 	
	 	var windowWidth, windowHeight;
	 	if (self.innerHeight) {	// all except Explorer
	 		windowWidth = self.innerWidth;
	 		windowHeight = self.innerHeight;
	 	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
	 		windowWidth = document.documentElement.clientWidth;
	 		windowHeight = document.documentElement.clientHeight;
	 	} else if (document.body) { // other Explorers
	 		windowWidth = document.body.clientWidth;
	 		windowHeight = document.body.clientHeight;
	 	}	
	 	
	 	// for small pages with total height less then height of the viewport
	 	if(yScroll < windowHeight){
	 		pageHeight = windowHeight;
	 	} else { 
	 		pageHeight = yScroll;
	 	}
	 
	 	// for small pages with total width less then width of the viewport
	 	if(xScroll < windowWidth){	
	 		pageWidth = windowWidth;
	 	} else {
	 		pageWidth = xScroll;
	 	}
	 	arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight) 
	 	return arrayPageSize;
	 }  
	 
	function moveFrameToBody() 
	{
		var iframe = document.getElementById("iframe");
		
		// Depending on browser platform get the iframe's document, this is only
	   // available if the iframe has already been appended to an element which
	   // has been added to the document
	   if(iframe.contentDocument)
	      // Firefox, Opera
	      iframe.doc = iframe.contentDocument;
	   else if(iframe.contentWindow)
	      // Internet Explorer
	      iframe.doc = iframe.contentWindow.document;
	   else if(iframe.document)
	      // Others?
	      iframe.doc = iframe.document;
		
		var canvas = document.getElementsByTagName("body")[0].childNodes;
		
        var sourceCanvas = iframe.doc.getElementsByTagName("body")[0].childNodes;
        
        var i = 0;
        while (i < sourceCanvas.length) {
        	document.getElementsByTagName("body")[0].appendChild(sourceCanvas[0]);
        }
        
        // delete iframe
        document.getElementsByTagName("body")[0].removeChild(iframe);
		
		// try to get plugin back into mainpage
		var sourceParent = document.getElementsByClassName("vtnt-pi1"); 
		// falls nicht definiert
		if (sourceParent.length == 0) {
			//if not possible, delete it.
		    var existingVTnT = document.getElementsByTagName("body")[0].childNodes;
			var i = 0;
	        while (i < existingVTnT.length) {
	           if (existingVTnT[i].nodeType != 3 && (existingVTnT[i].id).search(/vTnT/) != -1) {
	           		document.getElementsByTagName("body")[0].removeChild(existingVTnT[i]);
	           } else {i++;}
	        };
		} else {
			source = sourceParent[0];
			try { 		    
	  		    // delete all already existing children of div.vtnt-pi1
				var sourceChildren = source.childNodes;
				while (sourceChildren.length > 0) {
				   source.removeChild(sourceChildren[0]);
				};
		
				// copy Children (vtnt and vTnTBackground) into plugin-area of html
				var existingVTnT = document.getElementsByTagName("body")[0].childNodes;
				
				var i = 0;
		        while (i < existingVTnT.length) {
		           if (existingVTnT[i].nodeType != 3 && (existingVTnT[i].id).search(/vTnT/) != -1) {
		           		source.appendChild(existingVTnT[i]);
		           } else {i++;}
		        };
			} catch (e) {};
		}
        return;    
	}

	 function IFrame(parentElement)
	{
	   // Create the iframe which will be returned
	   var iframe = document.createElement("iframe");
	   iframe.setAttribute("id","iframe");
	
	   // If no parent element is specified then use body as the parent element
	   if(parentElement == null)
	      parentElement = document.body;
	
	   // This is necessary in order to initialize the document inside the iframe
	   parentElement.appendChild(iframe);
	
	   // Initiate the iframe's document to null
	   iframe.doc = null;
	
	   // Depending on browser platform get the iframe's document, this is only
	   // available if the iframe has already been appended to an element which
	   // has been added to the document
	   if(iframe.contentDocument)
	      // Firefox, Opera
	      iframe.doc = iframe.contentDocument;
	   else if(iframe.contentWindow)
	      // Internet Explorer
	      iframe.doc = iframe.contentWindow.document;
	   else if(iframe.document)
	      // Others?
	      iframe.doc = iframe.document;
	
	   // If we did not succeed in finding the document then throw an exception
	   if(iframe.doc == null)
	      throw "Document not found, append the parent element to the DOM before creating the IFrame";
	
	   // Create the script inside the iframe's document which will call the
	   iframe.doc.open();
	   iframe.doc.close();
	
	   // Return the iframe, now with an extra property iframe.doc containing the
	   // iframe's document
	   return iframe;
	}
	
	function moveBodyToFrame()  
          {   
             var vtntModule = document.getElementById("vTnT");
             document.body.appendChild(vtntModule);
             
             var vtntModule = document.getElementById("vTnTBackground");
             document.body.appendChild(vtntModule);


             var canvas = document.getElementsByTagName("body")[0].childNodes;
             var canvas2 = document.getElementsByTagName("head")[0].childNodes;
             var iframe = new IFrame(); 
             
 			 iframe.style.width  = getPageSize()[0]+"px";
 			 iframe.style.height  = getPageSize()[1]+"px"; 			
   
             var div = iframe.doc.createElement("div");  

             for (var j = 0; j < canvas2.length; j++) {
                	iframe.doc.getElementsByTagName("head")[0].appendChild(canvas2[j].cloneNode(true));
             }
             
             var i =0;
             while (canvas.length > i) {
                if (canvas[i].id == 'iframe' || canvas[i].id == 'vTnT' || canvas[i].id == 'vTnTBackground' || canvas[i].id == 'log4JSConsole') {
                	i++;
                } else {
                	iframe.doc.body.appendChild(canvas[i]);
                }
             }  
             
             
          }  